import os

from ajenti.api import *
from ajenti.plugins.main.api import SectionPlugin
from ajenti.ui import on
from ajenti.ui.binder import Binder

from api import RAIDManager


@plugin
class RAID (SectionPlugin):

    @classmethod
    def verify(cls):
        return os.path.exists(RAIDManager.cli_path)

    def init(self):
        self.title = 'RAID'
        self.icon = 'hdd'
        self.category = 'Elements'

        self.append(self.ui.inflate('elements:megaraid-main'))

        self.mgr = RAIDManager.get()
        self.binder = Binder(self.mgr, self)

    def on_page_load(self):
        self.refresh()

    def refresh(self):
        self.mgr.refresh()
        self.binder.reset().autodiscover().populate()

    @on('silence', 'click')
    def on_silence(self):
        self.mgr.silence_alarm()
